//KonturAusrichten_202d.js
// 26.01.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//Dieses Script ndert die Kontur-Ausrichtung ausgewhlter Rahmen 
//von "mittig" auf "innen" (oder umgekehrt) und passt die Position 
//und Grsse der Objekte entsprechend an.

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Ein Dokument ffnen.");
	exit();
}

// den Bezugspunkt in der Mitte auswhlen
var trp = app.layoutWindows[0].transformReferencePoint;
if (trp != 1095656308) {
	app.layoutWindows[0].transformReferencePoint = 1095656308;
}

// die Auswahl prfen
var curSel = app.selection;
var nSel = curSel.length;

if (nSel == 0) {
	alert ("Es ist nichts ausgewhlt.");
	reStore(trp);
	exit();
}
else {
	modSel(curSel, nSel);
}

// den Handler zum Zurcksetzen des Bezugpunktes aufrufen
reStore(trp);

function modSel(curSel, nSel) {
	var actType;
	var actFrame;
	var curFrame;
	var curType;
	var topGroup;
	var unLock;
	var unLockParent;
	for (var i=0; i<nSel; i++) {
		// den aktuellen Rahmen der Variablen 'curFrame' zuweisen
		curFrame = curSel[i];
		// den Typ des Rahmens speichern
		curType = curFrame.constructor.name;
		// Elemente, welche keine Gruppierungen sind, der Funktion 
		// 'modFrame' bergeben, sonst nach 'modGroup' weiterleiten
		if (curType != "Group") {
			// den Rahmen feststellen, falls dieser nicht direkt 
			// ausgewhlt ist (= anwenderfreundlich :-)
			if (curType == "InsertionPoint" || curType == "Character" || curType == "Text" 
				|| curType == "Word" || curType == "Line" || curType == "Paragraph" 
				|| curType == "TextStyleRange" || curType == "TextColumn") {
				curFrame = curFrame.parent.textFrames.item(0);
			}
			// die Linienrahmen ausschliessen
			if (curType != "GraphicLine") {
				unLock = false;
				unLockParent = false;
				if (curFrame.locked == true) {
					unLock = true;
					try {
						curFrame.locked = false;
					}
					catch (e) {
						unLockParent = true;
						actType = "Group";
						actFrame = curFrame.parent;
						while (actType == "Group") {
							actType = actFrame.constructor.name;
							if (actType == "Group") {
								topGroup = actFrame;
							}
							try {
								actFrame.parent.locked = false;
							}
							catch (e) {
							}
							actFrame = actFrame.parent;
						}
					}
				}
				modFrame(curFrame);
				if (unLockParent == true) {
					try {
						topGroup.locked = true;
					}
					catch (e) {
					}
				}
				else if (unLock == true) {
					try {
						curFrame.locked = true;
					}
					catch (e) {
					}
				}
			}
		}
		else {
			unLock = false;
			if (curFrame.locked == true) {
				unLock = true;
				try {
					curFrame.locked = false;
				}
				catch (e) {
					alert ("Bitte die Sperrung der Rahmen aufheben.", "Stop");
					reStore(trp);
					exit();
				}
			}
			modGroup(curFrame);
			if (unLock == true) {
				try {
					curFrame.locked = true;
				}
				catch (e) {
				}
			}
		}
	}
}

function modGroup(curGroup) {
	var allFrames = curGroup.allPageItems;
	var nFrames = allFrames.length; 
	var unLock;
	for (var i=0; i<nFrames; i++) {
		curFrame = allFrames[i];
		curType = curFrame.constructor.name;
		if (curType != "Group") {
			if (curType != "GraphicLine") {
				unLock = false;
				if (curFrame.locked == true) {
					unLock = true;
					try {
						curFrame.locked = false;
					}
					catch (e) {
						alert ("Bitte die Sperrung der Rahmen aufheben.", "Stop");
						reStore(trp);
						exit();
					}
				}
				modFrame(curFrame);
				if (unLock == true) {
					try {
						curFrame.locked = true;
					}
					catch (e) {
					}
				}
			}
		}
	}
}

function modFrame(curFrame) {
	var curAlign = curFrame.strokeAlignment;
	// nur Rahmen, deren Konturstrke "innen" oder "mittig" ist, behandeln
	if (curAlign == StrokeAlignment.insideAlignment || curAlign == StrokeAlignment.centerAlignment) {
		try {
			// Dreh- und/oder Neigungswinkel auf Null setzen (falls notwendig)
			var curRot = curFrame.rotationAngle;
			if (curRot != 0) {
				curFrame.rotationAngle = 0;
			}
			var curShear = curFrame.shearAngle;
			if (curShear != 0) {
				curFrame.shearAngle = 0;
			}
			if (curAlign == StrokeAlignment.insideAlignment) {
				// Kontur mittig ausrichten 
				curFrame.strokeAlignment = StrokeAlignment.centerAlignment;
				// die neuen Werte der "bounds" zuweisen
				curFrame.visibleBounds = curFrame.geometricBounds;
			}
			else if (curAlign == StrokeAlignment.centerAlignment) {
				// die neuen Werte der "bounds" zuweisen
				curFrame.geometricBounds = curFrame.visibleBounds;
				// Kontur nach innen ausrichten 
				curFrame.strokeAlignment = StrokeAlignment.insideAlignment;
			}
			// Dreh- und/oder Neigungswinkel zurcksetzen
			if (curRot != 0) {
				curFrame.rotationAngle = curRot;
			}
			if (curShear != 0) {
				curFrame.shearAngle = curShear;
			}
		}
		catch (e) {
			alert ("Bitte die Sperrung der Rahmen aufheben.");
			reStore(trp);
			exit();
		}
	}
}

// den Bezugspunkt zurcksetzen (falls notwendig)
function reStore(trp) {
	if (trp != 1095656308) {
		app.layoutWindows[0].transformReferencePoint = trp;
	}
}